<template>
  <div>
    <div>
      <div class="course-list">
        <h3>Courses</h3>
        <nuxt-link to="/courses/create">Create New Course</nuxt-link> |
        <nuxt-link to="/courses/import">Import Course</nuxt-link> |
        <nuxt-link to="/my-courses">My Courses</nuxt-link>
        <el-input v-model="filter" placeholder="Search for courses" />
        <ul>
          <li v-for="course in courses.nodes" :key="course.id">
            <nuxt-link :to="`/courses/${course.id}`">
              {{ course.name || "Unnamed Course" }}
            </nuxt-link>
            <nuxt-link
              v-if="course.writeable"
              :to="`/courses/${course.id}/edit`"
              >[Edit]</nuxt-link
            >
          </li>
        </ul>
      </div>
    </div>
    <portal to="map">
      <div v-if="courses && courses.nodes && courses.nodes.length">
        <MglConfig @moveend="refresh" />
        <div v-for="course in courses.nodes" :key="course.id">
          <Course v-if="course.checkpoints.nodes.length" :value="course" />
        </div>
      </div>
    </portal>
  </div>
</template>

<script>
import { mapState } from "vuex";
import { pause } from "~/lib/utils";
import { query } from "~/plugins/data-management";
import MglConfig from "~/components/mapping/MglConfig";
import Course from "~/components/mapping/Course";

const FIELDS = `
fragment fields on Course {
    id name public description
     writeable
     owners:courseUsers(condition: { owner: true }, first: 1) {
        nodes {
          user {
            id name avatarUrl
          }
        }
      }
      startCheckpoint {
        lat lng
      }
      checkpoints(first:1) {
        nodes {
          lat lng
        }
      }
}`;

function queryFor(bounds, name) {
  let nameArg = "";
  let nameFilter = "";

  if (name) {
    nameArg = `$name: String`;
    nameFilter = `filter: { name: { includesInsensitive: $name } }`;
  }

  if (!bounds) {
    return (
      `query${nameArg ? "(" + nameArg + ")" : ""} {
courses(first: 100 orderBy: [CREATED_AT_DESC] ${nameFilter}) {
    nodes {
      ...fields
    }
  }
}` + FIELDS
    );
  }

  return (
    `
query($west:Float $north:Float $south:Float $east:Float ${nameArg}) {
courses:coursesWithinBounds(west: $west, north:$north, east:$east, south:$south
  ${nameFilter}
) {
    nodes {
      ...fields
    }
  }
}
  ` + FIELDS
  );
}
const FILTERED =
  `
  ` + FIELDS;

const DEFAULT_BOUNDS = {
  west: -360,
  east: 360,
  south: -90,
  north: 90,
};

export default {
  layout: "default",
  asyncData: query(queryFor()),
  data() {
    return {
      filter: null,
      bounds: null,
    };
  },
  components: {
    MglConfig,
    Course,
  },
  filters: {
    coordinates(value) {
      return value && [value.lng, value.lat];
    },
  },
  methods: {
    refresh(event) {
      const bounds = event.target.getBounds();
      this.bounds = {
        west: bounds.getWest(),
        east: bounds.getEast(),
        north: bounds.getNorth(),
        south: bounds.getSouth(),
      };
    },
    async fetch() {
      this._dirty = pause(300);
      if (this._fetching) return;

      this._fetching = true;
      try {
        while (this._dirty) {
          while (await this._dirty);
          this._dirty = false;
          const { result, error } = await Promise.race([
            this.$gql(queryFor(this.bounds, this.filter), {
              ...DEFAULT_BOUNDS,
              ...this.bounds,
              name: this.filter,
            }),
            pause(1000).then(Promise.resolve({ error: "timeout" })),
          ]);
          if (error == "timeout") {
            this._dirty = true;
            continue;
          }
          if (error) return this.$report(error);

          this.courses = result.courses;
        }
      } finally {
        this._fetching = false;
      }
    },
  },
  watch: {
    filter: "fetch",
    bounds: "fetch",
    async loggedOut() {
      const { result, error } = await this.$gql(queryFor());

      if (error) this.error = error;
      else {
        for (var k in result) {
          this.$set(this, k, result[k]);
        }
      }
    },
  },
};
</script>

<style lang="scss" scoped>
@import "~assets/mixins";
/*
.hero-bg {
  background:  url("https://static.wixstatic.com/media/add43d_09a0a4735bb549dbb2bd3fb1cb8808ed~mv2.png") no-repeat center;
  background-size: contain;
}
*/

.ui-column,
h1 {
  text-align: center;
}

h1 {
  color: $color-brand-primary;
  text-transform: uppercase;
  font-weight: 800;
}

.buttons {
  height: $grid * 1.5;
}

.button {
  margin: 0 $grid * 0.5;
}
</style>
